"""Add IP Trunk workflows.

Revision ID: a6eefd32c4f7
Revises: 3657611f0dfc
Create Date: 2023-08-14 15:50:03.376997

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = 'a6eefd32c4f7'
down_revision = '3657611f0dfc'
branch_labels = None
depends_on = None


from orchestrator.migrations.helpers import create_workflow, delete_workflow

new_workflows = [
    {
        "name": "create_iptrunk",
        "target": "CREATE",
        "description": "Create IP trunk",
        "product_type": "Iptrunk"
    },
    {
        "name": "terminate_iptrunk",
        "target": "TERMINATE",
        "description": "Terminate IPtrunk",
        "product_type": "Iptrunk"
    },
    {
        "name": "modify_trunk_interface",
        "target": "MODIFY",
        "description": "Modify IP Trunk interface",
        "product_type": "Iptrunk"
    },
    {
        "name": "modify_isis_metric",
        "target": "MODIFY",
        "description": "Modify IP trunk",
        "product_type": "Iptrunk"
    }
]


def upgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        create_workflow(conn, workflow)


def downgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        delete_workflow(conn, workflow["name"])
